//
//  ViewController.m
//  OffcnIMSDKiOS
//
//  Created by vockey on 2018/7/25.
//  Copyright © 2018年 中公教育. All rights reserved.
//

#import "ViewController.h"
#import "OffcnIMSDKiOS.h"
#import "OffcnNetworkExecutor.h"
#import <oimcore/oimcoreAdapter.h>

@interface ViewController ()<OIMCoreDelegate>

@property (weak, nonatomic) IBOutlet UIButton *changeEnvironmentBtn;


@property (strong, nonatomic) NSString *fromId;
@property (strong, nonatomic) NSString *toId;
@property (assign, nonatomic) OffcnSDKMsgType msg_type;
@property (strong, nonatomic) NSMutableDictionary *dataDic;

@property (strong, nonatomic) OIMCoreAdapter *adapter;
@end

@implementation ViewController

#pragma mark - 切换环境
- (IBAction)clickChangeEnvironmentBtnAction:(UIButton *)sender {
    sender.selected = !sender.isSelected;
    //中公直播使用测试环境设置为YES，正式环境设置为NO或者去掉这个配置
    [OffcnIMSDKiOS defaultService].isTest = sender.isSelected;

    [[NSUserDefaults standardUserDefaults] setValue:[NSNumber numberWithBool:[OffcnIMSDKiOS defaultService].isTest] forKey:kOffcnIMSDKiOS_changeEnvironment];
    [[NSUserDefaults standardUserDefaults] synchronize];
}

#pragma mark - 点我退出键盘
- (IBAction)clickExitKeyboardAction:(UIButton *)sender {
    [self.view endEditing:YES];
}
- (IBAction)connectAction:(UIButton *)sender {
    NSString *param = @"{\"server_ip\":\"39.102.42.185\", \"server_port\":6000, \"user_id\":\"ce0819db8391f1e7258a71cc9e2c3235\",\"app_id\":\"offcn_live\", \"device_type\":\"android\", \"token\":\"fadbce3f4929b6bdee0617fee34e32ae\"}";
    self.adapter = [OIMCoreAdapter sharedOIMCore];
    self.adapter.delegate = self;
    [self.adapter ConnectImServerWithParam:param];
}
-(void)OnOImCoreMessageWithMessage:(const char *_Nonnull)message msgLength:(int)len{
    
}

-(void)OnOImCoreEventWithCode:(int)code context:(const char *)context{
    
}

- (IBAction)disconnectAction:(UIButton *)sender {
    [self.adapter DisConnectImServer];
}
- (IBAction)sendMegAction:(UIButton *)sender {
    NSString *meg = @"qwe";
    [self.adapter SendUserMessage:meg length:(int)meg.length type:kMsg_Type_Normal];
}

//发送本地通知
- (IBAction)sendLocalNotiAction:(UIButton *)sender {
    
}

- (IBAction)sendMeg:(UIButton *)sender {
    //发送消息
    [OffcnNetworkExecutor requestSendMsgWithMsg_fromID:self.fromId msg_toID:self.toId msg_type:self.msg_type msg:self.dataDic Finished:^(BOOL success, id response, BaseResponse *baseResponse) {
        
    }];
}
- (IBAction)noReadListAction:(UIButton *)sender {
    //获取会话未读消息列表
    [OffcnNetworkExecutor requestGetSessionUnreadMsgWithFromID:self.fromId toID:self.toId Finished:^(BOOL success, id response, BaseResponse *baseResponse) {
        
    }];
}
- (IBAction)readedAction:(UIButton *)sender {
    //用户信息标记已读
    [OffcnNetworkExecutor requestMarkMsgReadWithMsg_fromID:self.fromId msg_toID:self.toId Finished:^(BOOL success, id response, BaseResponse *baseResponse) {
        
    }];
}
- (IBAction)recentVChatAction:(UIButton *)sender {
    //获取用户最近会话记录
    [OffcnNetworkExecutor requestGetRecentSessionsWithAccid:self.fromId Finished:^(BOOL success, id response, BaseResponse *baseResponse) {
        
    }];
}
- (IBAction)historyMegListAction:(UIButton *)sender {
    //获取会话历史消息列表,msg_seq当前时间的时间戳
    [OffcnNetworkExecutor requestGetSessionHistoryMsgWithFromID:self.fromId toID:self.toId msg_seq:@"" Finished:^(BOOL success, id response, BaseResponse *baseResponse) {
        
    }];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.title = @"demo";
    
    self.changeEnvironmentBtn.selected = [OffcnIMSDKiOS defaultService].isTest;
    
    self.fromId = @"ce0819db8391f1e7258a71cc9e2c3235";
    self.toId = @"jfdfjei0343";
    self.msg_type = OffcnSDKMsgTypeText;
    self.dataDic = [NSMutableDictionary dictionaryWithObject:@"我是一只小青龙" forKey:@"msg"];
}
-(NSString*)getAllCurrentTimes{
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
    
    NSDate *datenow = [NSDate date];
    NSString *currentTimeString = [formatter stringFromDate:datenow];
    return currentTimeString;
}
- (NSString *)documentPath{
    NSString *docDir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) firstObject];
    docDir = [docDir stringByAppendingPathComponent:@"test"];
    return docDir;
}
//可旋转屏幕
- (BOOL)shouldAutorotate {
    return NO;
}
/** 返回直接支持的方向 */
- (UIInterfaceOrientationMask)supportedInterfaceOrientations {
    return UIInterfaceOrientationMaskPortrait;
}

-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    [self.view endEditing:YES];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
@end
